      Program DMS2Deg

* Converts degrees, minutes, sec into degrees

* If the input is from a file, the format is as follows:

* header line (column headings if desired)
* stacode lat_deg lat_min lat_sec long_deg long_min long_sec 
* stacode lat_deg lat_min lat_sec long_deg long_min long_sec 
* stacode lat_deg lat_min lat_sec long_deg long_min long_sec 
* Stop

* Dates: 05/27/98 - Written by D. Boore
*        09/27/01 - Added option to read from file; ask for name of output file
*        10/01/01 - Corrected error in computing longitude when have negative
*                   degrees

      character f_in*40, f_out*40, from_screen*10, ext*3,
     :          buffer*80, buf_stop*4, stacode*4, sta_out*4

      write(*,'(a)') ' Enter f_out: '
999   continue
      f_out = ' '
      read(*,'(a)') f_out
      call trim_c(f_out,nc_f_out)
      ext = f_out(index(f_out,'.')+1: nc_f_out)
      call upstr(ext)
      call trim_c(ext,nc_ext)
      if(ext(1:2) .eq. 'IN') then
         write(*,'(a)') ' extension of f_out = IN; enter another'//
     :                  ' filename:'
         go to 999
      end if

      call get_lun(nu_out)
      open(unit=nu_out,file=f_out,status='unknown')

      write(*,'(a)') ' Get input from screen (Y/N)? '
      from_screen = ' '
      read(*,'(a)') from_screen
      
      call upstr(from_screen)
      call trim_c(from_screen, nc)

      if (from_screen(1:1) .eq. 'Y') then

1000    continue
        write(*,'(a\)') 
     :  ' Enter degrees, minutes, sec (0 0 0 to exit): '
        read(*, *) d, am, s

        signdeg = d/abs(d)
        degrees = abs(d) + (am+s/60.0)/60.0
        degrees = signdeg * degrees

        if (degrees .eq. 0.0) then
          close(nu_out)
          stop
        end if

        write(*,'(a,1x,f10.5)') ' Degrees = ', degrees

        write(nu_out,'(1x,i4,a,1x,i2,a,1x,f5.2,a,1x,f10.5,a)') 
     :    int(d), 'd', int(am), 'm', s, 's = ', degrees, ' degrees'

        go to 1000

      else   ! get input from a file

        f_in = ' '
        write(*,'(a)') ' Enter f_in: '
        read(*,'(a)') f_in
        call get_lun(nu_in)
        open(unit=nu_in,file=f_in,status='unknown')
        write(nu_out,'(t2,a, t12,a, t22,a)') 'sta', 'lat', 'long'
        read(nu_in,*)    ! skip the header
2000    continue
        buffer = ' '
        read(nu_in,'(a)') buffer
        call trim_c(buffer,nc_buf)
        buf_stop = buffer(1:4)
        call upstr(buf_stop)
        if (buf_stop .eq. 'STOP') then
          close(nu_in)
          close(nu_out)
          stop
        end if         
        call RCC (1,buffer,nc_buf,stacode,nc_stacode,ibgn,iend)
        call RCF (2,buffer,nc_buf,alatd,ibgn,iend, ISTAT)
        call RCF (3,buffer,nc_buf,alatm,ibgn,iend, ISTAT)
        call RCF (4,buffer,nc_buf,alats,ibgn,iend, ISTAT)
        call RCF (5,buffer,nc_buf,alongd,ibgn,iend, ISTAT)
        call RCF (6,buffer,nc_buf,alongm,ibgn,iend, ISTAT)
        call RCF (7,buffer,nc_buf,alongs,ibgn,iend, ISTAT)

        signlat = alatd/abs(alatd)
        alat = abs(alatd) + (alatm+alats/60.0)/60.0
        alat = signlat * alat

        signlong = alongd/abs(alongd)
        along = abs(alongd) + (alongm+alongs/60.0)/60.0
        along = signlong * along

        sta_out = ' '
        sta_out(4 - nc_stacode + 1: 4) = stacode(1:nc_stacode)
        write(nu_out,'(a4,1x,f9.5,1x,f10.5)') sta_out, alat, along
        go to 2000

      end if

      end

      include '\forprogs\get_lun.for'
      include '\forprogs\trim_c.for'
      include '\forprogs\upstr.for'
      include '\forprogs\rc_subs.for'


     