      Program Dst4Pair

! Compute distance and azimuths for pairs of coordinates:

! Sample control file:
!Name of output file:
!  dst4pair.out
!Sign of west longitude:
! +1.0
!Coordinates (in pairs, comment followed by pairs of coordinates)
!  JAB-JGB
! 34.31151 118.49665  JAB
! 34.31299 118.49884  JGB
!  JAB-JABF
! 34.31151 118.49665  JAB
! 34.31088 118.49654  JABF
! stop    (This must start in column 2)

! Dates: 06/02/98 - Written by D. Boore (modified from DISTANCE.FOR)
!        08/11/98 - added west long. sign
!        10/19/01 - Obtain default name of control file via CR and
!                   update code (calling get_lun, etc)
!        05/31/03 - Write name of output file to screen
!        12/02/03 - Minor mods so can use LF95 compiler (use trim_c)
!        08/07/06 - Allow longer file names
!        11/24/07 - Trap for colocated pair in subroutine distaz
!        11/18/15 - Some modernization of code
!        11/25/16 - Increase precision of azimuth output

      character f_ctl*100, f_out*100, buf*60, buf4*4
      double precision alat_1, along_1
      double precision alat_2, along_2
     
      logical f_ctl_exist

      f_ctl_exist = .false.
      do while (.not. f_ctl_exist)
        f_ctl = ' '
        write(*, '(a\)') 
     :    ' Enter name of control file (cr=DST4PAIR.CTL;'//
     :    ' CTL-BRK to quit): '
        read(*, '(a)') f_ctl
        if (f_ctl(1:4) == '    ') f_ctl = 'dst4pair.ctl'
        call trim_c(f_ctl,nc_f_ctl)
        inquire(file=f_ctl(1:nc_f_ctl), exist=f_ctl_exist)
        if (.not. f_ctl_exist) then
          write(*,'(a)') ' ******* FILE DOES NOT EXIST ******* '
        end if
      end do
      call trim_c(f_ctl,nc_f_ctl)
      call get_lun(nu_ctl)
      open(nu_ctl, file=f_ctl(1:nc_f_ctl), status = 'unknown')
      write(*, '(1x,a)') ' Control file: '//f_ctl(1:nc_f_ctl)

! Obtain info from control file:

      call skip(nu_ctl,1)
      f_out = ' '
      read(nu_ctl, '(a)') f_out
      call trim_c(f_out,nc_f_out)
      call get_lun(nu_out)
      open(nu_out, file=f_out(1:nc_f_out), status = 'unknown')
      call skip(nu_ctl,1)
      read(nu_ctl,*) sign_west_longitude
      write(*,'(1x,a,1x,f5.1)') 
     : ' sign_west_longitude = ', sign_west_longitude
      write(nu_out,'(1x,a,1x,f5.1)') 
     : ' sign_west_longitude = ', sign_west_longitude
          
      call skip(nu_ctl,1)

      loop_over_input: DO

        buf = ' '
        read(nu_ctl, '(a)') buf
        write(*, '(1x,a)') buf
        write(nu_out,*)
        write(nu_out,'(a)') buf
        call trim_c(buf,nc_buf)
        buf4 = ' '
        buf4 = buf(1:4)
        call upstr(buf4)
        if(buf4 == 'STOP') then
          write(*,'(a)') ' Results written to '//f_out(1:nc_f_out)
          close(nu_ctl)
          close(nu_out)
          stop
        end if
      
        read(nu_ctl,*) alat_1, along_1
        read(nu_ctl,*) alat_2, along_2
        write(*, *) alat_1, along_1
        write(*, *) alat_2, along_2

        write(nu_out, '(a)') ' Double precision: '
        write(nu_out, *) alat_1, along_1
        write(nu_out, *) alat_2, along_2

        call distazdp( sign_west_longitude, alat_1, along_1, 
     :                   alat_2, along_2, 
     :                   rdeg, rkm, az, baz)

        write(nu_out, '(2x,a, 2(1x,es10.3),2(1x,f6.2))')
     :     'dst(degree), dst(km), az, baz = ', 
     :     rdeg, rkm, az, baz

        write(nu_out, '(a)') ' Single precision: '
        write(nu_out, *) sngl(alat_1), sngl(along_1)
        write(nu_out, *) sngl(alat_2), sngl(along_2)

        call distaz( sign_west_longitude, sngl(alat_1), sngl(along_1), 
     :                   sngl(alat_2), sngl(along_2), 
     :                   rdeg, rkm, az, baz)
        write(nu_out, '(2x,a, 2(1x,es10.3),2(1x,f6.2))')
     :     'dst(degree), dst(km), az, baz = ', 
     :     rdeg, rkm, az, baz

      END DO loop_over_input

      end

      include '\forprogs\distazdp.for'
      include '\forprogs\distaz.for'
      include '\forprogs\get_lun.for'
      include '\forprogs\upstr.for'
      include '\forprogs\trim_c.for'
      include '\forprogs\skip.for'
